#include<bits/stdc++.h>
#define xx first
#define yy second
#define pb push_back

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

int n, q, par[1010], sz[1010], niz[1010];
bool ok;
vector<pair<pii, pii>> kv;
int fnd(int a) {
    if(a==par[a]) return a;
    return par[a]=fnd(par[a]);
}
void merg(int a, int b) {
    a=fnd(a); b=fnd(b);
    if(sz[a]<sz[b]) swap(a, b);
    par[b]=a;
    sz[a]+=sz[b];
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> q;
    ok=1;
    for(int i=1; i<=q; i++) {
        int t, u, v;
        char c;
        cin >> t >> u >> v;
        if(t==1) {
            cin >> c;
            if(c!='a') ok=0;
        }
        kv.pb({{t, u}, {v, (t==1?0:c-'a')}});
    }
    if(ok) {
        for(int i=1; i<=n; i++) {
            par[i]=i;
            sz[i]=1;
        }
        for(auto x:kv) {
            if(x.xx.xx==1) {
                merg(x.xx.yy, x.yy.xx);
            }
            else {
                if(fnd(x.xx.yy)==fnd(x.yy.xx)) cout << 1;
                else cout << 0;
                cout << "\n";
            }
        }
    }
    else {
        for(auto x:kv) {
            if(x.xx.xx==1) {
                niz[x.xx.yy]=x.yy.yy+1;
            }
            else {
                int mini=min(x.xx.yy, x.yy.xx), maxi=max(x.xx.yy, x.yy.xx);
                bool sta=1;
                for(int i=mini; i<=mini+(maxi-1-mini)/2; i++) {
                    if(niz[i]==0 || niz[maxi-1-i+mini]==0 || niz[i]!=niz[maxi-1-i+mini]) {sta=0; break;}
                }
                cout << sta << "\n";
            }
        }
    }
    return 0;
}